#include "TIOSlib.h"
#include "vi92.h"

void GoInInputMode(int After)
{
 int exit = 0, key, Len;
 tLigne * LigneCurseur;
 int IsDeletable = 0, CursorCharDeletable;

 InputMode = 1;
 ExtraChar = 0;


 do
 {
  CursorFit();
  BufferDisplay(Buffer);
  if(!After)
  {
     while(!kbhit());
     key = ReadKey();
  }
  else
  {
     key = 0x154;
     After = 0;
  }

  switch(key)
  {
   case 0x108: if(CursorChar > 1) CursorChar--;
               ExtraChar = 0;
               exit = 1;
               break; /* esc */


   case 0x958: // Deplacement curseur vers le bas
   case 0x158: if(CursorLine < Buffer->NbLignes) CursorLine++;
               if(ExtraChar) CursorChar--;
               ExtraChar = 0;
               IsDeletable = 0;
               break;
   case 0x952: // Deplacement curseur vers le haut
   case 0x152: if(CursorLine > 1) CursorLine--;
               if(ExtraChar) CursorChar--;
               ExtraChar = 0;
               IsDeletable = 0;
               break;
   case 0x954: // Deplacement curseur vers la droite
   case 0x154: Len = BufferLigne(Buffer, CursorLine)->Longueur;
               if(CursorChar < Len)
               {
                  CursorChar++;
                  ExtraChar = 0;
               }
               else
               {
                  CursorChar = Len + 1;
                  ExtraChar = 1;
               }
               IsDeletable = 0;
               break;
   case 0x951: // Deplacement curseur vers la gauche
   case 0x151: if(CursorChar > 1) CursorChar--;
               Len = BufferLigne(Buffer, CursorLine)->Longueur;
               if(CursorChar > Len) CursorChar = Len - 1;
               ExtraChar = 0;
               IsDeletable = 0;
               break;

   case 0xD  : LigneCurseur = BufferLigne(Buffer, CursorLine);
               BufferInsererLigne(Buffer, CursorLine);
               LigneRemplacerTexte(LigneCurseur->LigneSuivante, LigneCurseur->Texte + CursorChar - 1);
               LigneTronquer(LigneCurseur, CursorChar - 1);
               CursorLine++;
               CursorChar = 1;
               IsDeletable = 0;
               break;

   case 0x901:
   case 0x101: if(IsDeletable && (CursorChar > CursorCharDeletable))
               {
                  LigneCurseur = BufferLigne(Buffer, CursorLine);
                  CursorChar--;
                  LigneSupprimerCaractere(LigneCurseur, CursorChar);
               }
               break;


   default   : if(key <= 255) // On ajuste d'abord CursorChar
               {
                  LigneCurseur = BufferLigne(Buffer, CursorLine);
                  Len = LigneCurseur->Longueur;
                  if(Len == 0) ExtraChar = 1;
                  if(CursorChar > Len + 1) CursorChar = Len + 1;
                  if((CursorChar > Len) && !ExtraChar) CursorChar = Len;
                  LigneInsererCaractere(LigneCurseur, CursorChar, key);
                  if(!IsDeletable)
                  {
                     IsDeletable = 1;
                     CursorCharDeletable = CursorChar;
                  }
                  CursorChar++;
               }
               break;
  }

               if(CursorChar <= 0) CursorChar = 1;

 } while(!exit);


 InputMode = 0;

}
