#include "setjmp.h"

int setjmp(jmp_buf *env)
{
// asm("trap #13;");

 /* Save data registers D1 through D7.  */
 asm volatile("movem%.l %/d1-%/d7, %0" : : "m" (env->__dregs[0]));

 /* Save return address in place of register A0.  */
 env->__aregs[0] = (void*) ((void* *) &env)[-1];

 /* Save address registers A1 through A5.  */
 asm volatile("movem%.l %/a1-%/a5, %0" : : "m" (env->__aregs[1]));

 /* Save caller's FP, not our own.  */
 env->__fp = (void*) ((void* *) &env)[-2];

 /* Save caller's SP, not our own.  */
 env->__sp = (void*) &env;

 return 0;
}

void longjmp(jmp_buf *env, int val)
{
// asm("trap #13;");

  /* Put VAL in D0.  */
  asm volatile("move%.l %0, %/d0" : /* No outputs.  */ :
	       "g" (val == 0 ? 1 : val) : "d0");

  asm volatile(/* Restore the data and address registers.  */
	       "movem%.l %0, %/d1-%/d7/%/a0-%/a7\n"
	       /* Return to setjmp's caller.  */
	       "jmp %/a0@" :
	       /* No outputs.  */ : "g" (env->__dregs[0])
	       /* We don't bother with the clobbers,
		  because this code always jumps out anyway.  */
	       );
}
