#ifndef TIOSlib__h
#define TIOSlib__h

typedef unsigned long size_t;
typedef unsigned long HSym;

typedef unsigned int tHandle;

#define NULL ((void *)0)

typedef struct
{
 char Name[10];
 unsigned int Flags;
 tHandle Handle;
} FolderEntry;



#define RETURN_VAR (_RAM_CALL_00F)
char * RETURN_VAR;


#define GET_PARAM (_ROM_CALL_109)
char * GET_PARAM;


#define strlen _ROM_CALL_27E
size_t strlen(const char *);


#define free _ROM_CALL_0A3
void free(void *);


#define SymAdd _ROM_CALL_05C
HSym SymAdd(char * Name); // Attention : Name doit etre le zero terminal du nom (qui doi commencer par un 0)
                          // Si le fichier existe -> libere le handle et remplace !


#define DerefSymb _ROM_CALL_079
FolderEntry * DerefSymb(HSym sym);


#define HeapAlloc _ROM_CALL_090
tHandle HeapAlloc(size_t size);


#define strchr _ROM_CALL_274
char * strchr(char * s, int c);

#define strcpy _ROM_CALL_26C
char * strcpy(char * dest, const char * src);


#define memcpy _ROM_CALL_26A
void *memcpy(void *dest, void *src, size_t n);


#define strncpy _ROM_CALL_26D
char strncpy(char * dest, const char * src, size_t n);


#define HeapAllocPtr _ROM_CALL_0A2
void * HeapAllocPtr(size_t size);


#define SymFindPtr _ROM_CALL_283
FolderEntry * SymFindPtr(char * FileName, int n);


#define HeapDeref _ROM_CALL_096
char * HeapDeref(unsigned int Handle);

#define strcmp _ROM_CALL_271
int strcmp(char *s1, char *s2);

#define strcat _ROM_CALL_26E
char *strcat(char *dest, char *src);

#define sprintf _ROM_CALL_053
int sprintf(char *buffer, char *format, ...);

void ReturnListFromInt(int * Tab, int nb);

void ReturnString(char * str);

int GetIntParameter(int * param);

int GetStrnParameter(char * str, size_t n);

void *bcopy(void * s, void * d, int n);

char * gets(char FirstChar);

void * malloc(size_t size);

#endif