#include "ctype.h"
#include "vi92.h"
#include "TIOSlib.h"

void GoInExmode()
{
 char * str;
 int i, n;
 FolderEntry * Entry;


 str = gets(':');

 if(str[0] == ':')
 {

    if(isdigit(str[1]))
    {
       i = 2;
       n = str[1] - '0';
       while(str[i] && isdigit(str[i]))
       {
          n *= 10;
          n += str[i] - '0';
          i++;
       }
       if(str[i] == 0)
       {
          if(!n) n = 1;
          if(n <= Buffer->NbLignes)
             CursorLine = n;
          else
             regerror("Not that many line in buffer");
       }
    }
    else if(strcmp(":nu", str) == 0)
    {
       DispLineNumber = 1;
       BufferAjusteHauteur(Buffer);
    }
    else if(strcmp(":nu!", str) == 0)
    {
       DispLineNumber = 0;
       BufferAjusteHauteur(Buffer);
    }
    else if(strcmp(":$", str) == 0)
    {
       CursorLine = Buffer->NbLignes;
    }
    else if(strcmp(":w", str) == 0)
    {
       Entry = DerefSymb(SymAdd("\0vibuffer" + 9));
       Entry->Handle = BufferSave(Buffer);
       Buffer->Modified = 0;
    }
    else if(strcmp(":q", str) == 0)
    {
       if(!Buffer->Modified)
          QuitProg = 1;
       else
          regerror("Buffer not saved since last change");
    }
    else if(strcmp(":q!", str) == 0)
    {
       QuitProg = 1;
    }
    else if(strcmp(":wq", str) == 0)
    {
       Entry = DerefSymb(SymAdd("\0vibuffer" + 9));
       Entry->Handle = BufferSave(Buffer);
       QuitProg = 1;
    }

 }
}
