	.file	"plottxt.s"

.text
	.even

TableRoutines:
        .long Routine0,Routine1,Routine2,Routine3
        .long Routine4,Routine5,Routine6,Routine7

# PlotChar :
# d0.w = Car
# d1.w = x
# d2.w = y
# modifie en plus d7, a0, a1 et a2
PlotChar:
        clr.b   %d7
        cmp.w   CursorY,%d2
        bne     NotCursor
        cmp.w   CursorX,%d1
        bne     NotCursor
        tst.w   InputMode
        beq     NotInputMode
        move.b  #0b11111100,%d7
        bra     NotCursor
NotInputMode:
        move.b  #0b11000000,%d7
NotCursor:
# a0 = &font_medium
        move.l  #_RAM_CALL_00E,%a0       
# d0 = d0 * 8 (offset du car)
        lsl.w   #3,%d0
# a0 = offset du car
        lea     (%a0,%d0.w),%a0   

# a1 = adresse LCD MEM
        move.l  VideoBuffer,%a1       
# d2 = offset du dbut de la ligne
        mulu.w  #240,%d2         
# a1 = adresse du dbut de la ligne
        lea     (%a1,%d2.w),%a1   

        move.w  %d1,%d0
        lsr.w   #3,%d0
# d0 = offset du dbut du bloc de 3 words
        mulu.w  #6,%d0
# a1 = adresse du dbut du bloc de 3 words
        lea     (%a1,%d0.w),%a1   

        move.w  %d1,%d0
# d0 = numro de la routine
        and.w   #7,%d0
# d0 = offset dans TableRoutines
        lsl.w   #2,%d0
        lea     (TableRoutines,%pc),%a2
        move.l  (%a2,%d0.w),%a2
        jmp     (%a2)


# a0 = adresse du car
# a1 = adresse du bloc

Routine0:
        moveq.l #7,%d0
        BclRoutine0:
                and.b   #0b00000011,(%a1)
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                or.b    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine0

        bra     FinPlotChar

Routine1:
        moveq.l #7,%d0
        BclRoutine1:
                and.w   #0b1111110000001111,(%a1)
                clr.w   %d1
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                lsl.w   #2,%d1
                or.w    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine1

        bra     FinPlotChar

Routine2:
        moveq.l #7,%d0
        BclRoutine2:
                and.l   #0b11111111111100000011111111111111,(%a1)
                clr.l   %d1
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                swap    %d1
                lsr.l   #4,%d1
                or.l    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine2

        bra     FinPlotChar

Routine3:
        moveq.l #7,%d0
        addq.l  #2,%a1
        BclRoutine3:    
                and.b   #0b11000000,(%a1)
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                lsr.b   #2,%d1
                or.b    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine3

        bra     FinPlotChar
        
Routine4:
        moveq.l #7,%d0
        addq.l  #3,%a1
        BclRoutine4:    
                and.b   #0b00000011,(%a1)
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                or.b    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine4

        bra     FinPlotChar

Routine5:
        moveq.l #7,%d0
        addq.l  #2,%a1
        BclRoutine5:
                and.l   #0b11111111111111000000111111111111,(%a1)
                clr.l   %d1
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                swap    %d1
                lsr.l   #6,%d1
                or.l    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine5

        bra     FinPlotChar

Routine6:
        moveq.l #7,%d0
        addq.l  #4,%a1
        BclRoutine6:
                and.w   #0b1111000000111111,(%a1)
                clr.w   %d1
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                lsl.w   #4,%d1
                or.w    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine6

        bra     FinPlotChar

Routine7:
        moveq.l #7,%d0
        addq.l  #5,%a1
        BclRoutine7:    
                and.b   #0b11000000,(%a1)
                move.b  (%a0)+,%d1
                eor.b   %d7,%d1
                lsr.b   #2,%d1
                or.b    %d1,(%a1)
                lea     30(%a1),%a1
        dbf     %d0,BclRoutine7

        bra     FinPlotChar

FinPlotChar:
        rts



.globl PlotText
# int PlotText(char * str, int y)#
PlotText:
        movem.l %d1-%d5/%d7/%a0-%a3,-(%a7)

# a3 = str
        move.l  4+10*4(%a7),%a3
# d3 = y
        move.w  8+10*4(%a7),%d3
# d5 = x = 0
        clr.w   %d5

# compteur de boucle -> 40 cars max
        move.w  #39,%d4
        BclPlotText:
                move.w  %d3,%d2
                move.w  %d5,%d1
                clr.w   %d0
                move.b  (%a3)+,%d0
                beq     FinPlotText
                bsr     PlotChar

                addq.w  #1,%d5
        dbf     %d4,BclPlotText


FinPlotText:
        move.w  %d5,%d0
        movem.l (%a7)+,%d1-%d5/%d7/%a0-%a3
        rts

.globl malloc        
malloc:
        move.l  %d3,-(%a7)
        subq.l  #8,%a7
        move.w  #0x96,(%a7)
        jsr     _ROM_CALL_0A4
        move.l  16(%a7),%d0
        addq.l  #2,%d0
        move.l  %d0,(%a7)
        bsr     myHeapAllocHigh
        move.w  %d0,%d3
        bne     PasFin
        suba.l  %a0,%a0
        bra     FinMyMalloc
PasFin:
        move.w  %d3,%d0
        lsl.w   #2,%d0
        movea.l (0x7592),%a1
        move.l  0(%a1,%d0.w),4(%a7)
        lea     4(%a7),%a1
        movea.l (%a1),%a0
        addq.l  #2,(%a1)
        move.w  %d3,(%a0)
        movea.l 4(%a7),%a0
FinMyMalloc:
        addq.l  #8,%a7
        move.l  (%a7)+,%d3
        rts

myHeapAllocHigh:
        link    %a6,#-8
        move.l  %d3,-4(%a6)
        move.w  #0x88,-(%a7)
        jsr     _ROM_CALL_0A4
#        jsr     HeapCompress

        move.l  %a0,-(%a7)

        move.w  #0x1,-(%a7)
        move.l  8(%a6),-(%a7)

#        jsr     0x49BD8C
        lea     _ROM_CALL_092,%a0
        lea     30(%a0),%a0
        clr.l   %d0
        move.w  (%a0),%d0
        add.l   %d0,%a0
        jsr     (%a0)

        addq.l  #8,%a7

        move.l  (%a7)+,%a0

        move.w  %d0,%d3
        beq     NoError
        move.w  %d3,-(%a7)
        jsr     _ROM_CALL_09A
        bra     FinmyHeapAllocHigh
NoError:
        moveq   #0,%d0
FinmyHeapAllocHigh:
        move.l  -4(%a6),%d3
        unlk   %a6
        rts

